<?php
// Survey database interface class as intermediate for storing data from the site to the RDF database 
require_once 'rdfConstants.php';

// Include RAP Library to write RDF files
include(RDFAPI_INCLUDE_DIR . "RDFAPI.php");

class SurveyAnswerDatabaseInterface extends SurveyCreationDatabaseInterface
{
    protected $surveyAnswerRDFReader;
    protected $surveyAnswerRDFWriter;
    
    public function __construct($surveyID,$sessionID,$respondentID)
    {
        parent::__construct($surveyID);
        if($respondentID == null)
            $respondentID = md5( uniqid(rand(), true) );
        else
            $respondentID = $respondentID;
        
        $this->surveyAnswerRDFReader = new SurveyAnswerRDFReader($surveyID,$sessionID,$respondentID);
        $this->surveyAnswerRDFWriter = new SurveyAnswerRDFWriter($surveyID,$sessionID,$respondentID);
    }
        
    public function setRespondentInfo($respondentInfo)
    {
        $name = $respondentInfo['username'];
        $this->surveyAnswerRDFWriter->setRespondentData($name);
    }
    
    public function setSurveyAnswers($answers)
    {
        $questionAnswerList = array();
        
        $qNumber = 1;
        while (isset($survey['questionID'.$qNumber]))
        {
            $qID = $survey['questionID'.$qNumber];
            $aArray = array();
            
            $aNumber = 1;
            while (isset($survey['q'.$qNumber.'result'.$aNumber]))
            {
                $aArray[] = $survey['q'.$qNumber.'result'.$aNumber];

                $aNumber++;
            }
                
            $questionAnswerList[$qID] = $aArray;

            $qNumber++;
        }
        
        $this->surveyAnswerRDFWriter->setAnswers($questionAnswerList);
    }
}
?>